---
title: DOMPoint
slug: Web/API/DOMPoint
tags:
  - API
  - Coordinate
  - Coordinates
  - DOM
  - DOMPoint
  - Geometry
  - Geometry Interfaces
  - Interface
  - Point
  - Reference
  - VR
---
<div>{{APIRef("DOM")}}</div>

<p><span class="seoSummary">A <strong><code>DOMPoint</code></strong> object represents a 2D or 3D point in a coordinate system; it includes values for the coordinates in up to three dimensions, as well as an optional perspective value.</span> <code>DOMPoint</code> is based on {{domxref("DOMPointReadOnly")}} but allows its properties' values to be changed.</p>

<p>In general, a positive <code>x</code> component represents a position to the right of the origin, a positive <code>y</code> component is downward from the origin, and a positive <code>z</code> component extends outward from the screen (in other words, toward the user).</p>

<h2 id="Constructor">Constructor</h2>

<dl>
	<dt>{{domxref("DOMPoint.DOMPoint","DOMPoint()")}}</dt>
	<dd>Creates and returns a new <code>DOMPoint</code> object given the values of zero or more of its coordinate components and optionally the <code>w</code> perspective value. You can also use an existing <code>DOMPoint</code> or <code>DOMPointReadOnly</code> or a {{domxref("DOMPointInit")}} dictionary to create a new point by calling the {{domxref("DOMPoint.fromPoint()")}} static method.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em><code>DOMPoint</code> inherits methods from its parent, {{domxref("DOMPointReadOnly")}}.</em></p>

<dl>
	<dt>
	<h2 id="Static_methods">Static methods</h2>
	</dt>
	<dt>{{domxref("DOMPoint.fromPoint()", "DOMPoint.fromPoint()")}}</dt>
	<dd>Creates a new mutable <code>DOMPoint</code> object given an existing point (or a {{domxref("DOMPointInit")}} dictionary) which provides the values for its properties.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em><code>DOMPoint</code> inherits properties from its parent, {{domxref("DOMPointReadOnly")}}.</em></p>

<dl>
	<dt>{{domxref("DOMPointReadOnly.x", "DOMPoint.x")}}</dt>
	<dd>The <code>x</code> coordinate of the <code>DOMPoint</code>.</dd>
	<dt>{{domxref("DOMPointReadOnly.y", "DOMPoint.y")}}</dt>
	<dd>The <code>y</code> coordinate of the <code>DOMPoint</code>.</dd>
	<dt>{{domxref("DOMPointReadOnly.z", "DOMPoint.z")}}</dt>
	<dd>The <code>z</code> coordinate of the <code>DOMPoint</code>.</dd>
	<dt>{{domxref("DOMPointReadOnly.w", "DOMPoint.w")}}</dt>
	<dd>The perspective value of the <code>DOMPoint</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a>, <code>DOMPointReadOnly</code> values are used to represent positions and orientations. In the following snippet, the pose of the XR device (such as a VR headset or phone with AR capabilities) can be retrieved by calling using {{domxref("XRFrame.getViewerPose()")}} during an {{domxref("XRSession")}} animation frame, then accessing the resulting {{domxref("XRPose")}}'s {{domxref("XRPose.transform","transform")}} property, which contains two <code>DOMPointReadOnly</code> attributes: {{domxref("XRRigidTransform.position","position")}} as a vector and {{domxref("XRViewerPose.orientation","orientation")}} as a quaternion.</p>

<pre class="brush: js">function onXRFrame(time, xrFrame) {
  let viewerPose = xrFrame.getViewerPose(xrReferenceSpace);

  if (viewerPose) {
    let position = viewerPose.transform.position;
    let orientation = viewerPose.transform.orientation;

    console.log('XR Viewer Position: {x: ' + roundToTwo(position.x)
                                 + ', y: ' + roundToTwo(position.y)
                                 + ', z: ' + roundToTwo(position.z));

    console.log('XR Viewer Orientation: {x: ' + roundToTwo(orientation.x)
                                    + ', y: ' + roundToTwo(orientation.y)
                                    + ', z: ' + roundToTwo(orientation.z)
                                    + ', w: ' + roundToTwo(orientation.w));
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('Geometry Interfaces', '#DOMPoint', 'DOMPoint')}}</td>
			<td>{{Spec2('Geometry Interfaces')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMPoint")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("DOMRect")}}</li>
	<li>{{domxref("DOMMatrix")}}</li>
</ul>
